#include <iostream>

struct Vehicle {
  enum class VehicleType{
    HooverVehicle, // = 0
    GroundVehicle  // = 1
  };

  virtual VehicleType getVehicleType() const = 0;
};

struct Car: public Vehicle {
  VehicleType getVehicleType() const override {
    return VehicleType::GroundVehicle;
  };
};

struct MonsterTruck: public Car {
  VehicleType getVehicleType() const override  {
    return VehicleType::HooverVehicle;
  };
};

int main()
{
  using namespace std;

  MonsterTruck monsterTruck;
  Car& car = monsterTruck;
  cout << "Vehicle Type: " << static_cast<int>(car.getVehicleType()) << endl;
}

