#include <vector>
#include <iostream>

template<class ANumber>
struct AbsCalculator {
  virtual ANumber addNumbers(ANumber firstNumber, ANumber secondNumber){
    return (firstNumber + secondNumber);
  }
};

struct IntegerCalculatorBase {
  virtual int addIntegerNumbers(int firstNumber, int secondNumber) = 0;
};

struct FinalIntegerCalculator final : public IntegerCalculatorBase {
  int addIntegerNumbers(int firstNumber, int secondNumber) override {
    return (firstNumber + secondNumber);
  }
};

struct NonFinalIntegerCalculator : public IntegerCalculatorBase {
  int addIntegerNumbers(int firstNumber, int secondNumber) override {
    return (firstNumber + secondNumber);
  }
};

int main (){
int addends1[10] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
int addends2[10] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
int sum[10];

AbsCalculator<int> templateCalculator;
for (int ii = 0; ii < 10; ii++){
  sum[ii] = templateCalculator.addNumbers(addends1[ii], addends2[ii]);
}
std::cout << sum[0] << std::endl;

NonFinalIntegerCalculator* nonFinalPointer = new NonFinalIntegerCalculator();
for (int ii = 0; ii < 10; ii++){
  sum[ii] = nonFinalPointer->addIntegerNumbers(addends1[ii], addends2[ii]);
}
std::cout << sum[0] << std::endl;

FinalIntegerCalculator* finalPointer = new FinalIntegerCalculator();
for (int ii = 0; ii < 10; ii++){
  sum[ii] = finalPointer->addIntegerNumbers(addends1[ii], addends2[ii]);
}
std::cout << sum[0] << std::endl;
}

