#include <iostream>

/** Struct to hold information about cars. 
 *
 *  To have multiple cars of a certain different type, you can inherit from this struct.
 */
struct Car {
    /** Returns a generic estimate of the weight of a car (1 ton), if not overriden.*/
    virtual int getWeightInKg();

    /** Returns a generic estimate of the speed of a car (180), if not overriden.*/
    virtual int getMaxSpeedInKmh() const;
    
    /** Returns a generic estimate of the number of wheels of a car (4), if not overriden.*/
    virtual int getNWheels();
    
    /** Returns a generic estiate of the number of seats in a car (5), if not overrriden.*/
    int getNSeats();
};

/** Class to use with the bigger and slower Monster Truck spcial car.*/
struct MonsterTruck: public Car {
  /** Monster Trucks are much heavier on average the averge cars (3 tons).*/
  int getWeightInKg();

  /** Monster Trucks are much slower than average cars (80).*/
  int getMaxSpeedInKmh();
    
  /** Monster Trucks have double wheels (--> 8) due to their big weight.*/
  virtual int getNWheels();
  
  /** Monster Trucks have one big front bench with 3 seats.*/
  int getNSeats();
};

int main()
{
  using namespace std;

  MonsterTruck monsterTruck;
  Car& car = monsterTruck;
  cout << "Weight:           " << car.getWeightInKg() << endl;
  cout << "Speed:            " << car.getMaxSpeedInKmh() << endl;
  cout << "Number of Wheels: " << car.getNWheels() << endl;
  cout << "Number of Seats:  " << car.getNSeats() << endl;

  cout << "Once more the Speed: "           << monsterTruck.getMaxSpeedInKmh() << endl;
  cout << "Once more the number of Seats: " << monsterTruck.getNSeats() << endl;
}

//---------------------------------------------------------------------------------

int Car::getWeightInKg(){
  return 1000;
}

int MonsterTruck::getWeightInKg(){
  return 3000;
}

int Car::getMaxSpeedInKmh() const {
  return 180;
}

int MonsterTruck::getMaxSpeedInKmh() {
  return 80;
}

int Car::getNWheels() {
  return 4;
}

int MonsterTruck::getNWheels() {
  return 8;
}

int Car::getNSeats(){
  return 5;
}

int MonsterTruck::getNSeats(){
  return 3;
}

